
##### TP de Gntique Quantitative: estimation de l'hritabilit d'un caractre  partir de donnes familiales #####

### Exploration prliminaire des donnes
## Ouvrir le fichier "pheno_pedigree.txt", appelez le data:
data=

## informations sur les individu/familles
dim(data)
length(table(data$family))
length(table(data$father))
length(table(data$mother))
hist(table(data$family))
mean(table(data$family))

## informations sur les caractres


## correction des donnes phnotypiques par le facteur sexe

data$weight_corr=resid(lm(data$weight ~ 0 + as.factor(data$sex))) 
data$height_corr=resid(lm(data$height ~ 0 + as.factor(data$sex))) 

### Estimation de l'hritabilit et influence de l'chantillonnage sur la prcision de l'estimation

## La boucle qui suit permet de calculer la covariance "frre vs frre" en chantillonnant des paires de frres
# dans toutes les familles et en calculant la covariance entre les deux vecteurs de valeurs
# la procdure peut tre rptes, ce qui permet d'avoir une ide de la prcision de l'estimation de l'hritabilit
###############################################################################################


table(data$family)
# the list of families is
listfam=names(table(data$family))

#how many families? 
nfam=length(listfam)

# We can repeat this a few times !!
# subset() : Return subsets of vectors, matrices or data frames which meet conditions. 
# sample() : takes a sample of the specified size from the elements of x using either with or without replacement. 
h2=NA
for (ii in 1:200){

        # prepare two vectors, the i'th case contains the weights of two animals from the same family
        # then we can compute the covariance of vector1 with vector 2 and find out the genetic covariance
        vec1=rep(NA,nfam)
        vec2=rep(NA,nfam)

        # do a loop picking two animals by family
        pos=0
        for (i in listfam){
                pos=pos+1
                aux=subset(data,family==i)
                # if the family has more than one member
                if(nrow(aux)>1){
                         aux2=sample(aux$weight_corr,2)  
				 #aux2=sample(aux$height_corr,2)
                        vec1[pos]=aux2[1]; vec2[pos]=aux2[2]
                }
        }
      
        # the covariance (between this 2 vectors of full-sibs) is
        covp= cov(vec1,vec2,use="complete.obs")

        # the genetic variance is the covariance (Covg) /additive relationship (aij), which is 0.5 (i.e., cov(Gx,Gy)=VarG*Axy)
	  # coefficient phi(i,j) pour des plein frres est de 0.25 ; additive relationship=2* phi(i,j)=2*0.25=0.5
        varg=covp/0.5

        # total phenotypic variance is...
		  varp=var(data$weight)
		  #varp=var(data$height)
		  
        # and heritability:
        h2[ii]=varg/varp
		
        cat("heritabilit", h2[ii],ii,"\n")
}



